#ifndef ENTITY_H
#define ENTITY_H

#include "olcPGEX_Graphics2D.h"
#include "olcPixelGameEngine.h"
#include <cmath>

namespace pabloader {
class Debuggers;

class Entity {
protected:
    Debuggers* game;
    olc::GFX2D::Transform2D transform;
    float x, y;
    float xv, yv;
    int w, h;

public:
    Entity(Debuggers* game_);
    virtual ~Entity(){};

    virtual void Update(float dt) = 0;
    virtual void Draw() = 0;

    float GetX() { return x; }
    float GetY() { return y; }

    bool Collides(Entity* entity);
    float Dist(Entity* entity) { return std::hypot(x - entity->x, y - entity->y); }
};
}

#endif