#ifndef PROGRAMMER_H
#define PROGRAMMER_H

#include "entity.h"
#include "olcPGE_Common.h"

namespace pabloader {

class Programmer : public Entity {
protected:
    uint8_t tile = 0;
    uint32_t tileCounter = 0;
    uint8_t skin = 0;
    bool onGround = false;
    bool doJump = false;
    bool walkLeft = false;
    bool walkRight = false;
    bool moveDown = false;

public:
    Programmer(Debuggers* game);
    virtual void Think();
    virtual void Update(float dt) override;
    virtual void Draw() override;
    bool IsOnGround() { return onGround; }
    uint8_t GetSkin() { return skin; }
    void UpgradeLevel() { skin = std::min(skin + 1, 2); }
};
}

#endif