#include "bug.h"
#include "debuggers.h"
#include <iostream>
#include <random>

namespace pabloader {
Bug::Bug(Debuggers* game_)
    : Entity(game_)
{
    w = game->enemiesSprite.width / 4;
    h = game->enemiesSprite.height / 4;
}

void Bug::Update(float dt)
{
    y += yv * dt;
    yv += 30 * dt;
}

void Bug::Draw()
{
#ifdef _DEBUG
    game->DrawRect(x - w / 2, y - h / 2, w, h, olc::RED);
#endif
    game->DrawPartialSprite(x, y, &game->enemiesSprite, 0, kind * h, w, h, 1, true);
}

bool Bug::IsActive()
{
    return y - h / 2 < game->GameScreenHeight();
}

void Bug::ResetPosition()
{
    y = -20 - std::rand() % 100;
    x = w + std::rand() % (game->ScreenWidth() - w * 2);
    yv = 0;
    kind = std::rand() % 4;
}

void Bug::Kill()
{
    y = game->GameScreenHeight() + 100;
}
}